
package com.ywt.biz.common.config.redission.properties;


import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;


/**
 * redisson 配置暂用spring-redis
 * @author liyang
 */

@ConfigurationProperties(prefix = "redisson")
@Data
public class RedissonProperties {

    private String model;
    private int timeout = 3000;
    private String schema = "redis://";
    private String host;
    private String port;
    private int database;
    private String password;
    private int connectionPoolSize = 64;
    private int connectionMinimumIdleSize = 10;
    private int slaveConnectionPoolSize = 250;
    private int masterConnectionPoolSize = 250;
    private String[] sentinelAddresses;
    private String masterName;

}

