package com.ywt.biz.common.constant;

/**
 * 用于 kafka 的主题定义规则
 * 规则：方法名-类名-模块-能力中心
 * 规则对应最新能力中心划分的方式来(倒序是为了方便引用)
 */
public class KafkaTopicsConstants {

    /**
     * 我清除缓存
     */
    public static final String INVALIDATECACHE_SYSTEMSERVICEPROVIDER_RPC_INTERNETHOSPITAL = "invalidateCache.SystemServiceProvider.rpc.internethospital";

    /**
     * 转换视频格式
     */
    public static final String CONVERTVIDEO2MP4_VIDEOPROVIDER_RPC_BASESERVICE = "convertVideo2Mp4.VideoProvider.rpc.baseservice";

    /**
     * 根据日志表ID发送小程序模板消息（旧）
     */
    public static final String SENDMPTEMPLATEMESSAGEBYLOGID_WECHATMSGPROVIDER_RPC_MSG = "sendMPTemplateMessageByLogId.WeChatMsgProvider.rpc.msg";

    /**
     * 根据日志表ID发送小程序订阅消息（新）
     */
    public static final String SENDMPSUBSCRIBEMESSAGEBYLOGID_WECHATMSGPROVIDER_RPC_MSG = "sendMPSubscribeMessageByLogId.WeChatMsgProvider.rpc.msg";

    /**
     * 异步方法发送模板消息。这个是真正发送模板消息的方法。
     */
    public static final String SENDTEMPLATEMESSAGEASYNC_WECHATMSGPROVIDER_RPC_MSG = "sendTemplateMessageAsync.WeChatMsgProvider.rpc.msg";

    /**
     * 眼镜店退款 rest 回调
     */
    public static final String REFUNDCALLBACK_GLASSESAPISERVICE_REST_MSG = "rest:__com.ywt.GlassesApiService_mg_order_refundCallback";
    /**
     * 营养餐微信自动退款 rest 回调
     */
    public static final String AUTOWECHATREFUNDCALLBACK_NUTRIMEALAPISERVICE_REST_MSG = "rest:__com.ywt.NutrimealApiService_mealOrder_autoWechatRefundCallback";
    /**
     * 营养餐退款 rest 回调
     */
    public static final String REFUNDCALLBACK_NUTRIMEALAPISERVICE_REST_MSG = "rest:__com.ywt.NutrimealApiService_mealOrder_refundCallback";

    /**
     * 眼镜店支付 rest 回调
     */
    public static final String PAYMENTCALLBACK_GLASSESAPISERVICE_REST_MSG = "rest:__com.ywt.GlassesApiService_mg_order_paymentCallback";
    /**
     * 营养餐微信充值成功 rest 回调
     */
    public static final String FINISHINGCHARGING_NUTRIMEALAPISERVICE_REST_MSG = "rest:__com.ywt.NutrimealApiService_balance_finishCharging";
    /**
     * 营养餐支付成功 rest 回调
     */
    public static final String FINISHPAYING_NUTRIMEALAPISERVICE_REST_MSG = "rest:__com.ywt.NutrimealApiService_order_finishPaying";


    /**
     *同步诊疗卡信息
     */
    public static final String SYNCMEDCARD_USERSERVICEPROVIDER_RPC_INTERNETHOSPITAL = "syncMedCard.UserServiceProvider.rpc.internethospital";

    /**
     * 转码视频回调接口
     */
    public static final String CONVERTVIDEOCALLBACK_ARTICLESERVICEPROVIDER_RPC_INTERNETHOSPITAL = "convertVideoCallback.ArticleServiceProvider.rpc.internethospital";
    /**
     * 公共视频回调
     */
    public static final String PUBLISHVIDEOCALLBACK_VIDEOPROVIDER_RPC_BASESERVICE = "publishVideoCallback.VideoProvider.rpc.baseservice";

}
