package com.ywt.biz.common.enums;

public enum PaymentChannelEnum {
    WeChat("微信", 1),
    AliPay("支付宝", 2),
    Cash("现金", 3),          //现场支付
    MedicalCard("诊疗卡", 4),
    POS("平台pos机", 5),
    FREE("无须支付", 6),
    MedicalInsurance("医保", 7),
    ICBC("工行", 8),
    PharmacyPOS("药店pos机", 9), // v4.6.5 处方外传增加支付渠道
    PharmacyUnion("门店聚合", 10), // hotfix_v1.1.0 处方外传增加支付渠道
    UNKNOWN("", 0);

    private final String displayName;

    private final int value;

    PaymentChannelEnum(String displayName, int value) {
        this.displayName = displayName;
        this.value = value;
    }

    public String getDisplayName() {
        return displayName;
    }

    public int getValue() {
        return value;
    }

    public static PaymentChannelEnum valueOf(int value) {
        for (PaymentChannelEnum e : PaymentChannelEnum.values()) {
            if (e.getValue() == value) {
                return e;
            }
        }
        return UNKNOWN;
    }
}
