package com.ywt.biz.common.enums;


public enum SexEnum {
    Unknown("未知", 0),
    Male("男", 1),
    Female("女", 2),
    Unspecified("未说明", 9);

    private final String displayName;

    private int value = 0;

    SexEnum(String displayName, int value) {
        this.displayName = displayName;
        this.value = value;
    }

    public String getDisplayName() {
        return displayName;
    }

    public int getValue() {
        return value;
    }

    public static SexEnum valueOf(int value) {
        switch (value) {
            case 1:
                return Male;
            case 2:
                return Female;
            case 9:
                return Unspecified;
            default:
                return Unknown;
        }
    }

    public static String getSexDisplayName(int value){
        SexEnum sexEnum = valueOf(value);

        if(sexEnum != null){
            return sexEnum.getDisplayName();
        }

        return "未知";
    }

    public static SexEnum getByVal(int value) {
        for(SexEnum sexEnum : SexEnum.values()){
            if(sexEnum.getValue() == value){
                return sexEnum;
            }
        }
        return null;
    }

    public static SexEnum getByName(String displayName) {
        for(SexEnum sexEnum : SexEnum.values()){
            if(sexEnum.getDisplayName().equals(displayName)){
                return sexEnum;
            }
        }
        return null;
    }
}