package com.ywt.biz.common.structs;

import java.util.HashMap;
import java.util.List;

/**
 * 多叉树类
 */
public class MultipleTree {

    /**
     * 多叉树根节点
     */
    private TreeNode root;

    private List<TreeNode> tempNodeList;


    public MultipleTree() {
    }

    public MultipleTree(List<TreeNode> treeNodeList) {
        tempNodeList = treeNodeList;
        generateTree();
    }

    public TreeNode getRoot() {
        return root;
    }

    public void setRoot(TreeNode root) {
        this.root = root;
    }

    /**
     * 生成多叉树
     */
    public void generateTree() {
        int maxId = Integer.MAX_VALUE;
        HashMap<String, TreeNode> map = new HashMap<>();

        for(TreeNode treeNode : tempNodeList){
            if(treeNode.getId() < maxId){
                maxId = treeNode.getId();
                this.root = treeNode;
            }

            map.put(String.valueOf(treeNode.getId()), treeNode);
        }

        for (String key : map.keySet()) {
            TreeNode treeNode = map.get(key);
            int parentId = treeNode.getParentId();
            String parentKeyId = String.valueOf(parentId);

            if (map.containsKey(parentKeyId)) {
                TreeNode parentNode = map.get(parentKeyId);

                if (parentNode == null) {
                    //节点不能构成一棵多叉树
                    return;
                } else {
                    parentNode.addChildNode(treeNode);
                }
            }
        }
    }
}
