package com.ywt.biz.common.structs;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * 树节点类
 */
public class TreeNode implements Serializable {
    private int parentId;
    private int id;
    private String label;
    private List<TreeNode> children;

    public TreeNode() {
        initChildren();
    }


    public void addChildNode(TreeNode treeNode) {
        initChildren();
        children.add(treeNode);
    }

    private void initChildren() {
        if (children == null) {
            children = new ArrayList<>();
        }
    }

    public List<TreeNode> getChildren() {
        return children;
    }

    public void setChildren(List<TreeNode> children) {
        this.children = children;
    }

    public int getParentId() {
        return parentId;
    }

    public void setParentId(int parentId) {
        this.parentId = parentId;
    }

    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    // 孩子节点排序
    public void sortChildren() {
        Collections.sort(children, new IdComparator());

        // 对节点的子节点进行排序
        for(TreeNode node : children){
            node.sortChildren();
        }
//        for (Iterator it = children.iterator(); it.hasNext(); ) {
//            ((TreeNode) it.next()).sortChildren();
//        }
    }

    /**
     * 节点比较器
     */
    class IdComparator implements Comparator {
        // 按照节点编号比较
        public int compare(Object o1, Object o2) {
            int j1 = (((TreeNode) o1).getId());
            int j2 = (((TreeNode) o2).getId());
            return (j1 < j2 ? -1 : (j1 == j2 ? 0 : 1));
        }
    }

}

