package com.ywt.biz.common.util;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Map;

/**
 * @author Walker
 * Created on 2019/9/4
 */
public final class DoubleUtil {
    private static final Logger logger = LoggerFactory.getLogger(DoubleUtil.class);

    public static double subtract(String a, String b) {
        return new BigDecimal(a).subtract(new BigDecimal(b)).doubleValue();
    }
    public static double subtract(double a, double b) {
        return subtract(String.valueOf(a), String.valueOf(b));
    }
    public static double subtract(Double a, Double b) {
        return subtract(String.valueOf(Checker.getDoubleValue(a)), String.valueOf(Checker.getDoubleValue(b)));
    }

    public static double add(String a, String b) {
        return new BigDecimal(a).add(new BigDecimal(b)).doubleValue();
    }
    public static double add(double a, double b) {
        return add(String.valueOf(a), String.valueOf(b));
    }
    public static double add(Double a, Double b) {
        return add(String.valueOf(Checker.getDoubleValue(a)), String.valueOf(Checker.getDoubleValue(b)));
    }

    public static double multiply(String a, String b) {
        return new BigDecimal(a).multiply(new BigDecimal(b)).doubleValue();
    }
    public static double multiply(double a, double b) {
        return multiply(String.valueOf(a), String.valueOf(b));
    }
    public static double multiply(Double a, Double b) {
        return multiply(String.valueOf(Checker.getDoubleValue(a)), String.valueOf(Checker.getDoubleValue(b)));
    }

    public static double divide(String a, String b) {
        return new BigDecimal(a).divide(new BigDecimal(b), 2, RoundingMode.HALF_UP).doubleValue();
    }
    public static double divide(double a, double b) {
        return divide(String.valueOf(a), String.valueOf(b));
    }
    public static double divide(Double a, Double b) {
        return divide(String.valueOf(Checker.getDoubleValue(a)), String.valueOf(Checker.getDoubleValue(b)));
    }

    public static double getDoubleFromMap(Map<String, Object> map, String key, double defaultValue) {
        Object o = map.get(key);
        if (o == null || !map.containsKey(key)) return defaultValue;
        if (o instanceof Integer) return (int) o;
        if (o instanceof Double) return (double) o;
        logger.warn("Maybe not a number type: " + o.toString());
        return defaultValue;
    }
}
