package com.ywt.biz.common.util;


import java.awt.*;
import java.awt.image.BufferedImage;
import java.awt.image.ImageObserver;
import java.io.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.*;
import java.util.List;


//import com.sun.image.codec.jpeg.JPEGCodec;
//import com.sun.image.codec.jpeg.JPEGImageEncoder;

import javax.imageio.ImageIO;

public class ImageUtil {

//    private static void createImage(String fileLocation, BufferedImage image) {
//        try {
//            File outputfile = new File(fileLocation);
//            ImageIO.write(image, "png", outputfile);
//
////            ByteArrayOutputStream out = new ByteArrayOutputStream();
////            ImageIO.write(image, "png", out);
////            byte[] b = out.toByteArray();
//
////            ServiceResult serviceResult = imService.uploadSessionMessageFile(filename, messageList);
//
//
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//    }

    private static final int paddingLeft = 35;

    private static final int paddingTop = 50;

    private static final int paddingBottom = 25;

    private static final int wordsPerRow = 22;

    private static final int rectWidth = 690;


    private static void drawString(Graphics graphics, String content, int num) {
        graphics.drawString(content, paddingLeft, num);
    }

    private static int drawLine(Graphics graphics, int num) {
        num += paddingBottom;

        Color color = new Color(204, 204, 204);
        graphics.setColor(color);
        graphics.drawLine(paddingLeft, num, 1150, num);
        graphics.setColor(Color.BLACK);

        num += paddingTop;

        return num;
    }

    private static int drawRowInfo(Graphics graphics, String content, int num) {
        drawString(graphics, content, num);
        return drawLine(graphics, num);
    }

    public static BufferedImage graphicsGeneration(String name, String strSex, int age, String fromHospital, String toHospital,
                                                   String toDoctorName, String toDoctorTitle, String diagnosis, String suggestion, String signUrl) throws IOException {

        int imageWidth = 750;// 图片的宽度

        int imageHeight = 1175;// 图片的初始高度（至"会诊意见"一行）


        int suggestionRowCount = suggestion.length() / wordsPerRow + (suggestion.length() % wordsPerRow == 0 ? 0 : 1);
        int suggestionHeight = (suggestionRowCount + 1) * 60;

        imageHeight += suggestionHeight;    //"会诊意见"一栏高度
        imageHeight += 160; //空行高度

        BufferedImage bufferedImage;
        int signImageHeight = 0;

        try {
            URL url = new URL(signUrl);
            bufferedImage = ImageIO.read(url);
            signImageHeight = bufferedImage.getHeight() * rectWidth / bufferedImage.getWidth();

        } catch (Exception e) {
            throw e;
        }

        imageHeight += signImageHeight; //签名图片高度
        imageHeight += 400;     //日期、备注高度

        BufferedImage image = new BufferedImage(imageWidth, imageHeight, BufferedImage.TYPE_INT_RGB);
        Graphics graphics = image.getGraphics();
        graphics.setColor(Color.white);
        graphics.fillRect(0, 0, imageWidth, imageHeight);
        graphics.setColor(Color.BLACK);
        graphics.setFont(new Font("微软雅黑", Font.PLAIN, 30));


        int num = 80;
//        graphics.drawString(, paddingLeft, num);
        List<String> contentList = Arrays.asList(
                "患者姓名　　　　　　" + name,
                "性别　　　　　　　　" + strSex,
                "年龄　　　　　　　　" + age,
                "申请单位　　　　　　" + fromHospital,
                "会诊单位　　　　　　" + toHospital,
                "会诊专家　　　　　　" + toDoctorName,
                "职称　　　　　　　　" + toDoctorTitle
        );

        for (String content : contentList) {
            num = drawRowInfo(graphics, content, num);
        }


        num += 40;
        graphics.drawString("初步诊断　　　　　　", paddingLeft, num);
        num += 50;
        graphics.drawRect(paddingLeft, num, rectWidth, 340);

        num += 30;

        int len = diagnosis.length() / wordsPerRow + (diagnosis.length() % wordsPerRow == 0 ? 0 : 1);
        int start = 0;

        for (int i = 0; i < len; i++) {
            start = i * wordsPerRow;
            if (i > 0) {
                start = start - 1;
            }

            int l = start + wordsPerRow;

            if (l > diagnosis.length()) {
                l = diagnosis.length() - 1;
            }

            String t = diagnosis.substring(start, l);
            num += 30;
            graphics.drawString(t, 50, num);
            num += 30;
        }

        if(len < 5){
            num += (5 - len) * 60;
        }

        num += 100;
        graphics.drawString("会诊意见", paddingLeft, num);
        num += 50;

//        int tttt = num;


        graphics.drawRect(paddingLeft, num, rectWidth, suggestionHeight);
        num += 30;
        start = 0;

        for (int i = 0; i < suggestionRowCount; i++) {
            start = i * 22;
            if (i > 0) {
                start = start - 1;
            }

            int l = start + 22;

            if (l > suggestion.length()) {
                l = suggestion.length() - 1;
            }

            String t = suggestion.substring(start, l);
            num += 30;
            graphics.drawString(t, 50, num);
            num += 30;
        }


        num += 100;

        graphics.drawString("会诊医生签名", paddingLeft, num);
        num += 50;


        graphics.drawImage(bufferedImage, paddingLeft, num, rectWidth, signImageHeight, new ImageObserver() {
            @Override
            public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height) {
                return false;
            }
        });

        num += signImageHeight + 50;
        graphics.drawString("日期: " + DateUtil.convertToString(new Date(), "yyyy年MM月dd日"), paddingLeft, num);
        num += 50;
        graphics.drawString("注：专家会诊意见，仅供申请单位参考。", paddingLeft, num);


//        createImage("/Users/bobotang/Desktop/test5.png", image);
        return image;
    }

//    public static void main(String[] args) {
//        String dig = "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然";
//        String suggestion = "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然" +
//                "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然"
//                + "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然"
//                + "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然"
//                + "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然"
//                + "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然"
//                + "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然"
//                + "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然"
//
//                + "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然"
//                + "进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然进入填写会诊报告页面（若医生填写部分，然";
//
////        suggestion = "进入填进入填进入填进入填进入填进入填进入填填";
//        String signUrl = "http://ywt-image.oss-cn-shenzhen.aliyuncs.com/doc/iu.png";
//        try {
//            graphicsGeneration("锋哥小号", "男", 23, "深圳市福田区第二人民医院", "南方医科大学南方医院", "郭城锋", "主任医师", dig, suggestion, signUrl);
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }
}